#include "mbed.h"
#include "TextLCD.h"

#include "stm32f4xx_hal.h"
#include "cmsis_os.h"

/* Private function prototypes -----------------------------------------------*/
static void SystemClock_Config(void);
static void StartThread(void const * argument);
void SerialThread(void const * argument);

Serial pc(SERIAL_TX, SERIAL_RX);
//Serial pc(PA_9, PA_10); //USART1 PA9/TX PA10/RX

Ticker flipper_1;
Ticker flipper_2;

DigitalOut led1(LED1);
DigitalOut led2(LED2);
DigitalOut led5(LED5);
DigitalOut led6(LED6);

int main() {
  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();
  /* Configure the system clock */
  SystemClock_Config();

  osThreadDef(USER_Thread, StartThread, osPriorityNormal, 0, 2 * configMINIMAL_STACK_SIZE);
  osThreadDef(SERIAL_Thread, SerialThread, osPriorityNormal, 0, 2 * configMINIMAL_STACK_SIZE);
  osThreadCreate (osThread(USER_Thread), NULL);
  osThreadCreate (osThread(SERIAL_Thread), NULL);

  /* Start scheduler */
  osKernelStart(NULL, NULL);


}

/** System Clock Configuration
*/
static void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct;

  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSI;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.HSICalibrationValue = 6;
  HAL_RCC_OscConfig(&RCC_OscInitStruct);

}

static void StartThread(void const * argument) {
  led1 = 1;

  int count = 1;
  while (true) {
      led5 = 0;
      led6 = 1;
      osDelay(100);
      led5 = 1;
      led6 = 0;
      osDelay(100);
  }

}

void SerialThread(void const * argument) {
  led2 = 1;
  pc.baud(115200);
  pc.printf("Hello World!\n");

  int count = 1;
  while (true) {
      pc.printf("This program runs since %d seconds.\n", count++);
      osDelay(1000);
  }

}
